let fibo =
  let tab = Hashtbl.create 101 in
  let rec aux count = function
    | (0|1) as x -> x
    | n ->
      incr count;
      try Hashtbl.find tab n with
        | Not_found ->
          Hashtbl.add tab n ((aux count (n-1)) + (aux count (n-2)));
          Hashtbl.find tab n
  in aux

let main () =
  let count = ref 0 in
  begin
    Printf.printf "fibo count 5 = %d (count = %d)\n"
      (fibo count 5) !count;
    count := 0;
    Printf.printf "fibo count 5 = %d (count = %d)\n"
      (fibo count 5) !count;
    count := 0;
    Printf.printf "fibo count 10 = %d (count = %d)\n"
      (fibo count 10) !count;
    count := 0;
    Printf.printf "fibo count 10 = %d (count = %d)\n"
      (fibo count 10) !count;
    for i = 10 to 90 do
      count := 0;
      Printf.printf "fibo count %d = %d (count = %d)\n"
        i (fibo count i) !count;
    done;
    exit 0
  end
let _ = main ()

